// ********************************************************************************** //
// The contents of this file are subject to the Mozilla Public License Version 1.1    //
// (the "License"); you may not use this file except in compliance with the License.  //
// You may obtain a copy of the License at http://www.mozilla.org/MPL/                //
//                                                                                    //
// Software distributed under the License is distributed on an "AS IS" basis,         //
// WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License for the  //
// specific language governing rights and limitations under the License.              //
//                                                                                    //
// The Original Code provided by Mozilla's Firefox is XUL, Javascript, and CSS.       // 
// The Initial Developer of the Original Code is Aseem Kishore.                       //
// Portions created by Scott Williamson are Copyright (c) 2006.  All Rights Reserved. //
// Contributor - Intuit Inc. (c) 2007                                                 //
// ********************************************************************************** //

// -- NODE DETAILS -- //


function thumbstrips_goToNode(thumbnailContainer, event)
{
	var visitCount = thumbnailContainer.getAttribute("vc");
	var sourceUrl = thumbnailContainer.getAttribute("SourceUrl");
	
	openUILink(sourceUrl, event, false, true);
	
	function getScrollPageListener(x, y) 
	{
		
//		return function() {
//			content.scrollTo(x, y);
//			document.getElementById("appcontent").removeEventListener("load", getScrollPageListener(x, y), true);
//		}

		var foo = new Object();
		
		foo.handleEvent = function(event) 
		{
			content.scrollTo(x, y);
			document.getElementById("appcontent").removeEventListener("load", foo, true);
		}
		
		return foo;

	}
	
    var webPageNode = thumbstrips_GetFilmstrip().GetWebPageNodeByUrl(sourceUrl);

	var ac = document.getElementById("appcontent");
	ac.addEventListener("load", getScrollPageListener(webPageNode.GetThumbnail().m_scrollX, webPageNode.GetThumbnail().m_scrollY), true);
}

function thumbstrips_checkForMiddleClick(node, event) 
{
	// native code:
//	if (event.button === 1) {
//		eval(node.getAttribute("oncommand"));
//		closeMenus(event.target);
//	}

	if (event.button == 2) 
	{
		return;
	}

	// modified code:
	var fn = new Function("event", node.getAttribute("oncommand"));
	fn.call(node, event); 
}



function thumbstrips_showNodeInfo(id) 
{
	// Show the URL of the page in the status bar
	var thumbnailContainer = document.getElementById(id);
	var sourceUrl = thumbnailContainer.getAttribute("SourceUrl");
	
	var sb = document.getElementById("statusbar-display");
	thumbstrips_statusBar = sb.getAttribute("label");
	sb.setAttribute("label", sourceUrl);
}

function thumbstrips_clearNodeInfo(id) 
{
	var sb = document.getElementById("statusbar-display");	
	sb.setAttribute("label", thumbstrips_statusBar);
}