
// ********************************************************************************** //
// The contents of this file are subject to the Mozilla Public License Version 1.1    //
// (the "License"); you may not use this file except in compliance with the License.  //
// You may obtain a copy of the License at http://www.mozilla.org/MPL/                //
//                                                                                    //
// Software distributed under the License is distributed on an "AS IS" basis,         //
// WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License for the  //
// specific language governing rights and limitations under the License.              //
//                                                                                    //
// The Original Code provided by Mozilla's Firefox is XUL, Javascript, and CSS.       // 
// All Rights Reserved. 
// Contributor - Intuit Inc. (c) 2007                                                 //
// ********************************************************************************** //

// -- INITIALIZATION -- //

var scrollBarIsShowing = false;

function SetScrollBarShowing(isShowing)
{
    scrollBarIsShowing = isShowing;
}

function IsScrollBarShowing()
{
    return scrollBarIsShowing;
}
/**
 * An object that listens for changes in browser location, preferences, etc.
 */
function thumbstripsFilmstripRenderer()
{
    this.m_thumbstripsWindow = document.getElementById("thumbstrips_box");
    this.m_thumbstripsTray = document.getElementById("thumbstrips_tray");
}

thumbstripsFilmstripRenderer.prototype.ClearContents = thumbstripsFilmstripRendererClearContents;
thumbstripsFilmstripRenderer.prototype.Draw = thumbstripsFilmstripRendererDraw;
thumbstripsFilmstripRenderer.prototype.UpdateDrawingContainer = thumbstripsFilmstripRendererUpdateDrawingContainer;
thumbstripsFilmstripRenderer.prototype.GetBoxHeight = thumbstripsFilmstripRendererGetBoxHeight;
thumbstripsFilmstripRenderer.prototype.GetTrayHeight = thumbstripsFilmstripRendererGetTrayHeight;
thumbstripsFilmstripRenderer.prototype.UpdateTime = thumbstripsFilmstripRendererUpdateTime;
thumbstripsFilmstripRenderer.prototype.UpdateTimes = thumbstripsFilmstripRendererUpdateTimes;
thumbstripsFilmstripRenderer.prototype.GetLastContainerForUrl = thumbstripsFilmstripRendererGetLastContainerForUrl;
thumbstripsFilmstripRenderer.prototype.GetLastContainer = thumbstripsFilmstripRendererGetLastContainer;
thumbstripsFilmstripRenderer.prototype.DoesMatchSearch = thumbstripsFilmstripRendererDoesMatchSearch;
thumbstripsFilmstripRenderer.prototype.UpdateSearchForAllNodes = thumbstripsFilmstripRendererUpdateSearchForAllNodes;
thumbstripsFilmstripRenderer.prototype.RelocateThumbnailContainer = thumbstripsFilmstripRendererRelocateThumbnailContainer;
thumbstripsFilmstripRenderer.prototype.Resize = thumbstripsFilmstripRendererResize;

function thumbstripsFilmstripRendererClearContents()
{
	for (i = 0; i < this.m_thumbstripsWindow.childNodes.length; i = 0) 
	{
		this.m_thumbstripsWindow.removeChild(this.m_thumbstripsWindow.childNodes[i]);
		this.m_thumbstripsWindow.childNodes[i] = null;
	}
}

function thumbstripsFilmstripRendererGetBoxHeight()
{
    var retVal = 0;
        
	if (IsScrollBarShowing()) 
	{	
		retVal = this.m_thumbstripsWindow.boxObject.height - 16;
    }
    else
    {
        retVal = this.m_thumbstripsWindow.boxObject.height;
    }
    
    return retVal;
}

function thumbstripsFilmstripRendererGetTrayHeight()
{
    var retVal = 0;
        
	if (IsScrollBarShowing()) 
	{	
		retVal = this.m_thumbstripsTray.boxObject.height - 16;
    }
    else
    {
        retVal = this.m_thumbstripsWindow.boxObject.height;
    }
    
    return retVal;
}

function thumbstripsFilmstripRendererDraw(redrawEntireFilmstrip)
{
	// If our current sorting is to show every visit, we need to keep track of
	// the various instances of each URL (visit counts)
	var visitCounts = new Array();
    var loadedThumbnails = thumbstrips_GetFilmstrip().m_thumbnailArray;
    
	// Then add each node in a container
	var thumbnailNodes = thumbstrips_GetFilmstrip().m_filmstripManager.m_xmlData.documentElement.selectNodes("//PageThumbnails/PageThumbnail");
	
	for(var i = 0; i < thumbnailNodes.length; i++)
	{
	    var thumbnailUrl = thumbnailNodes[i].getAttribute("SourceUrl");
	    var visitNodes = thumbstrips_GetFilmstrip().m_filmstripManager.m_xmlData.documentElement.selectNodes("//PageVisits/PageVisit[@SourceUrl='" + thumbnailUrl + "']");
	    visitCounts[thumbnailUrl] = visitNodes.length;
	    visitNodes = null;
    }

    thumbnailNodes = null;
    
    var sortManager = new thumbstripsSortManager();
    var sortMode = sortManager.GetSortMode();
    
    if(sortMode == sortModeManually)
	{	
	    var customSort = thumbstrips_GetFilmstrip().GetCustomSort();
	    
	    if(customSort.childNodes.length == 0) 
	    {
            sortManager.ChangeCurrentSortingPreference(false, false, false, true);	
	        sortMode = sortModeFirstVisit;
	    }
	    
	    customSort = null;    
	}
    
    sortManager = null;
    
    var allVisitNodes = thumbstrips_GetFilmstrip().GetSortedVisits(sortMode);
    
    if(redrawEntireFilmstrip==true)
    {
        this.ClearContents();
    }
    
    for(var i = 0; i < allVisitNodes.length; i++)
	{
	    if(sortMode==sortModeEveryVisit || sortMode == sortModeManually)
        {
             this.UpdateDrawingContainer(allVisitNodes[i], loadedThumbnails.FindByUrl(allVisitNodes[i].getAttribute("SourceUrl")), visitCounts[allVisitNodes[i].getAttribute("SourceUrl")], allVisitNodes[i].getAttribute("VisitIndex"));
        }
        else
            this.UpdateDrawingContainer(allVisitNodes[i], loadedThumbnails.FindByUrl(allVisitNodes[i].getAttribute("SourceUrl")), -1);        
    }    
    
    allVisitNodes = null;
    visitCounts = null;           
}

function thumbstripsFilmstripRendererUpdateDrawingContainer(visitInformationNode, thumbnailInformation, visitCount, visitIndex)
{    
    var identifier = visitInformationNode.getAttribute("SourceUrl");

    if(visitCount > 0)
        identifier = identifier + visitIndex;
    
    var thumbnailContainer = document.getElementById(identifier);
    
    if(thumbnailContainer==null)
    {        
        thumbnailContainer = document.createElement("vbox");
	    var padding = document.createElement("label");
        var title = document.createElement("label");
        
        var canvas = null;
        
        if(visitCount > 0)
        {
            canvas = thumbnailInformation.m_pageThumbnail.CreateNewCanvas();
        }
        else
        {
            canvas = thumbnailInformation.m_pageThumbnail.m_canvas;
        }        

        var popup = document.createElement("popup");
        var pDelete = document.createElement("menuitem");
        var pSep = document.createElement("menuseparator");
        var pProps = document.createElement("menuitem");
        var commentMenuItem = document.createElement("menuitem");
                	
        thumbnailContainer.setAttribute("class", thumbstrips_containerClass);
        thumbnailContainer.setAttribute("id", identifier);
        thumbnailContainer.setAttribute("oncommand", "thumbstrips_goToNode(this, event);");
        thumbnailContainer.setAttribute("onclick", "thumbstrips_checkForMiddleClick(this, event);");
        thumbnailContainer.setAttribute("onmouseover", "thumbstrips_showNodeInfo(\"" + identifier + "\");");
        thumbnailContainer.setAttribute("onmouseout", "thumbstrips_clearNodeInfo(\"" + identifier + "\");");
       
        thumbnailContainer.setAttribute("align", "center");
        thumbnailContainer.setAttribute("SourceUrl", thumbnailInformation.m_url);
        thumbnailContainer.setAttribute("Domain", thumbnailInformation.m_domain);
        thumbnailContainer.setAttribute("VisitIndex", visitInformationNode.getAttribute("VisitIndex"));
	    thumbnailContainer.setAttribute("LastUpdate", new Date());
    	
        if (visitCount > 0) 
        {
	        thumbnailContainer.setAttribute("vc", visitCount);
        }
    	
        padding.setAttribute("class", thumbstrips_paddingClass);
        padding.setAttribute("id", thumbstrips_paddingClass + identifier);
        padding.setAttribute("value", " ");
    	
        title.setAttribute("class", thumbstrips_titleClass);
        title.setAttribute("id", thumbstrips_titleClass + identifier);
        title.setAttribute("value", visitInformationNode.getAttribute("Domain"));
        title.setAttribute("crop", "end");
    //		title.setAttribute("hidden", "true");
    	
        popup.setAttribute("class", thumbstrips_popupClass);
        popup.setAttribute("id", thumbstrips_popupClass + identifier);
        popup.setAttribute("onclick", "event.preventBubble();");
        popup.appendChild(commentMenuItem);
        popup.appendChild(pDelete);
        popup.appendChild(pSep);
        popup.appendChild(pProps);
    	
        pDelete.setAttribute("label", thumbstrips_deleteLabel);
        pDelete.setAttribute("tooltiptext", thumbstrips_deleteTooltiptext);
    	
        if (visitCount > 0) 
        {
	        pDelete.setAttribute("oncommand", "thumbstrips_removeThumbnail('" + thumbnailInformation.m_url + "', '" + visitCount + "'); event.preventBubble();");
        } 
        else 
        {
	        pDelete.setAttribute("oncommand", "thumbstrips_removeThumbnail('" + thumbnailInformation.m_url + "'); event.preventBubble();");
        }
    	
        pProps.setAttribute("label", thumbstrips_propsLabel);
        pProps.setAttribute("tooltiptext", thumbstrips_propsTooltiptext);
    	
        if (visitCount > 0)
        {
	        pProps.setAttribute("oncommand", "thumbstrips_showProperties(\"" + identifier + "\", \"" + visitCount + "\"); event.preventBubble();");
        } 
        else 
        {
	        pProps.setAttribute("oncommand", "thumbstrips_showProperties(\"" + identifier + "\"); event.preventBubble();");
        }
    	
        commentMenuItem.setAttribute("label", thumbstrips_thumbnailCommentMenuItemLabel);
    	commentMenuItem.setAttribute("tootiptext", thumbstrips_thumbnailCommentMenuToolTip);
    	commentMenuItem.setAttribute("oncommand", "showEditCommentDialog('" + thumbnailInformation.m_url + "'); event.preventBubble();");

	    thumbnailContainer.setAttribute("ondraggesture", "nsDragAndDrop.startDrag(event,thumbstripsThumbnailContainerObserver);");
	    title.setAttribute("SourceUrl", thumbnailInformation.m_url);
	    title.setAttribute("ondraggesture", "nsDragAndDrop.startDrag(event,thumbstripsThumbnailContainerObserver);");
	    canvas.setAttribute("SourceUrl", thumbnailInformation.m_url);
	    canvas.setAttribute("ondraggesture", "nsDragAndDrop.startDrag(event,thumbstripsThumbnailContainerObserver);");

    //		container.appendChild(padding);
        thumbnailContainer.appendChild(title);
        thumbnailContainer.appendChild(canvas);
        this.UpdateTime(thumbnailContainer, new Date(visitInformationNode.getAttribute("VisitDate")));
        thumbnailContainer.appendChild(popup);
        thumbnailContainer.setAttribute("context", popup.id);
    	
        // if the canvas is hidden, the page hasn't loaded yet, hide the container
        if (canvas.width > 0) 
	    {
	        thumbnailContainer.setAttribute("hiddenWhileLoading", false);
	    }	
    	    	   		 	   		
        this.m_thumbstripsWindow.appendChild(thumbnailContainer);
    }
    else
    {
        if(thumbnailInformation.m_pageThumbnail.m_canvas.width > 0)
        {
            thumbnailInformation.m_pageThumbnail.m_canvas.setAttribute("SourceUrl", thumbnailInformation.m_url);
    	    thumbnailInformation.m_pageThumbnail.m_canvas.setAttribute("ondraggesture", "nsDragAndDrop.startDrag(event,thumbstripsThumbnailContainerObserver);");
                
             for(var j = 0; j < thumbnailContainer.childNodes.length; j++)
             {
                if(thumbnailContainer.childNodes[j].nodeName=="canvas")
                {
                    var lastUpdateDate = new Date(thumbnailContainer.getAttribute("LastUpdate"));
                    
                    if(lastUpdateDate < thumbnailInformation.m_lastUpdateDate)
                    {                                                
                        if(visitCount > 0)
                        {
                            thumbnailInformation.m_pageThumbnail.CopyToCanvas(thumbnailContainer.childNodes[j]);
                        }
                        else
                        {
                            var targetCanvas = thumbnailContainer.childNodes[j];
                            thumbnailContainer.removeChild(thumbnailContainer.childNodes[j]);
                            targetCanvas = null;
                            thumbnailContainer.insertBefore(thumbnailInformation.m_pageThumbnail.m_canvas, thumbnailContainer.childNodes[j]);                    
                        }
                    }   
                    
                    lastUpdateDate = null;         
                    break;
                }
            }
        }
    }
    
    if (thumbstrips_domainFiltering === false) 
    {
        thumbnailContainer.setAttribute("hiddenByDomain", false);
    } 
    else 
    {
        // if this domain is being filtered, hide the container
        thumbnailDomain = visitInformationNode.getAttribute("Domain");

        if (thumbstrips_currentDomains[thumbnailDomain] === true) 
        {
            thumbnailContainer.setAttribute("hiddenByDomain", false);
        } 
        else 
        {
            thumbnailContainer.setAttribute("hiddenByDomain", true);
        }
        
        thumbnailDomain = null;
    }

    thumbnailContainer.setAttribute("hiddenBySearch", !this.DoesMatchSearch(thumbnailInformation));
                    
    if(thumbnailContainer.getAttribute("hiddenByDomain")=="true" ||
       thumbnailContainer.getAttribute("hiddenBySearch")=="true")
    {
        thumbnailContainer.setAttribute("hidden", true);
    }
    else
    {
        thumbnailContainer.removeAttribute("hidden");
    } 
    
    thumbnailContainer = null;
}

function thumbstripsFilmstripRendererResize()
{
    if(this.m_thumbstripsWindow.childNodes.length > 0)
    {	
		var hBox = this.GetBoxHeight();
		
	    var hMin = thumbstrips_prefs.getIntPref("style.thumb_min_height");
	    var hMax = thumbstrips_prefs.getIntPref("style.thumb_max_height");
	    var hText = thumbstrips_textHeight;
	    var hNew = ((hBox - hText) < hMin) ? hMin : (((hBox - hText) > hMax) ? hMax : (hBox - hText));
    	
	    var scale = 1;
    	var newWidth = 1;
    	
	    for(var i = 0; i < this.m_thumbstripsWindow.childNodes[0].childNodes.length; i++)
        {
            if(this.m_thumbstripsWindow.childNodes[0].childNodes[i].nodeName=="canvas")
            {
	            scale = hNew / this.m_thumbstripsWindow.childNodes[0].childNodes[i].displayHeight;
	            newWidth = this.m_thumbstripsWindow.childNodes[0].childNodes[i].displayWidth * scale;
	            break;
	        }
	    }

	    for (var i = 0; i < this.m_thumbstripsWindow.childNodes.length; i++) 
	    {
	        var targetThumbnail = thumbstrips_GetFilmstrip().m_thumbnailArray.FindByUrl(this.m_thumbstripsWindow.childNodes[i].getAttribute("SourceUrl"));
	        
            targetThumbnail.m_pageThumbnail.m_canvas.displayHeight = hNew;
            targetThumbnail.m_pageThumbnail.m_canvas.displayWidth  = newWidth;

		     targetThumbnail.m_pageThumbnail.m_canvas.style.height = targetThumbnail.m_pageThumbnail.m_canvas.displayHeight + "px";
		     targetThumbnail.m_pageThumbnail.m_canvas.style.minHeight = targetThumbnail.m_pageThumbnail.m_canvas.style.height;
		     targetThumbnail.m_pageThumbnail.m_canvas.style.maxHeight = targetThumbnail.m_pageThumbnail.m_canvas.style.height;
    		
		     targetThumbnail.m_pageThumbnail.m_canvas.style.width = targetThumbnail.m_pageThumbnail.m_canvas.displayWidth + "px";
		     targetThumbnail.m_pageThumbnail.m_canvas.style.minWidth = targetThumbnail.m_pageThumbnail.m_canvas.style.width;
		     targetThumbnail.m_pageThumbnail.m_canvas.style.maxWidth = targetThumbnail.m_pageThumbnail.m_canvas.style.width;

	        for(var j = 0; j < this.m_thumbstripsWindow.childNodes[i].childNodes.length; j++)
            {
                if(this.m_thumbstripsWindow.childNodes[i].childNodes[j].nodeName=="canvas")
                {	
                    var canvasNode = this.m_thumbstripsWindow.childNodes[i].childNodes[j];
    				
		            canvasNode.displayHeight = hNew;
		            canvasNode.displayWidth  = newWidth;
    		
		            canvasNode.style.height = canvasNode.displayHeight + "px";
		            canvasNode.style.minHeight = canvasNode.style.height;
		            canvasNode.style.maxHeight = canvasNode.style.height;
    		
		            canvasNode.style.width = canvasNode.displayWidth + "px";
		            canvasNode.style.minWidth = canvasNode.style.width;
		            canvasNode.style.maxWidth = canvasNode.style.width;
		            break;
	            }
	        }
        }
    	
	    thumbstrips_currentHeight = hNew;
    }
}

function thumbstripsFilmstripRendererUpdateTime(containerNode, lastVisitDate)
{		
	var timeElement = document.getElementById(thumbstrips_timeClass + containerNode.id);
    
	if (!timeElement) 
	{
	    var timeElement = document.createElement("label");
	    timeElement.setAttribute("class", thumbstrips_timeClass);
	    timeElement.setAttribute("id", thumbstrips_timeClass + containerNode.id);
        timeElement.setAttribute("value", thumbstrips_getTimeAgo(lastVisitDate));
	    timeElement.setAttribute("crop", "end");
	    containerNode.appendChild(timeElement);
	}
	else
	{	
        timeElement.setAttribute("value", thumbstrips_getTimeAgo(lastVisitDate));
	}
}

function thumbstripsFilmstripRendererUpdateTimes() 
{
	var childNodes = this.m_thumbstripsWindow.childNodes;
	
	for (var i = 0; i < childNodes.length; i++) 
	{
        var sourceUrl = childNodes[i].getAttribute("SourceUrl");
        var webPageNode = thumbstrips_GetFilmstrip().GetWebPageNodeByUrl(sourceUrl);
        var currentChild = childNodes[i];
        
        if(webPageNode!=null)
        {            
            if (thumbstrips_prefs.getBoolPref("sorting.every_visit") === true) 
	        {	  
	            var visitIndex = currentChild.getAttribute("VisitIndex");
	            this.UpdateTime(currentChild, webPageNode.m_visitInformation.m_visitList[visitIndex]);
	        }
	        else if(thumbstrips_prefs.getBoolPref("sorting.last_visit") === true) 
	        {
	            this.UpdateTime(currentChild, webPageNode.m_visitInformation.m_visitList[webPageNode.m_visitInformation.m_visitList.length - 1]);
	        }
	        else
	        {
	            this.UpdateTime(currentChild, webPageNode.m_visitInformation.m_visitList[0]);
            }
        }	
        
        currentChild = null;
        webPageNode = null;    
	}
	
	childNodes = null;
}

function thumbstripsFilmstripRendererGetLastContainerForUrl(sourceUrl)
{
    var retVal = null;
    
    for(var i = this.m_thumbstripsWindow.childNodes.length - 1; i > -1; i--)
    {
        if(this.m_thumbstripsWindow.childNodes[i].getAttribute("SourceUrl")==sourceUrl)
        {
            retVal = this.m_thumbstripsWindow.childNodes[i];
            break;
        }
    }
    
    return retVal;
}

function thumbstripsFilmstripRendererGetLastContainer()
{
    var retVal = null;
    
    if(this.m_thumbstripsWindow.childNodes.length > 0)
        retVal = this.m_thumbstripsWindow.childNodes[this.m_thumbstripsWindow.childNodes.length - 1];
    
    return retVal;
}

function thumbstripsFilmstripRendererDoesMatchSearch(thumbnailInformationNode)
{
    var retVal = true;
    
    var stringToSearch = thumbnailInformationNode.m_title + thumbnailInformationNode.m_url + thumbnailInformationNode.m_pageText + thumbnailInformationNode.m_comment;
    	
	// if text is "" or search is positive on EVERY word, show it, else hide it
	for (var i = 0; i < thumbstrips_currentSearchPatterns.length; i++) 
	{
		if (thumbstrips_currentSearchPatterns[i] === "" || stringToSearch.search(thumbstrips_currentSearchPatterns[i]) >= 0) 
		{
			retVal = true;
		} 
		else 
		{
			retVal = false;
			break;
		}
	}

    return retVal;
}

function thumbstripsFilmstripRendererUpdateSearchForAllNodes()
{
	var childNodes = this.m_thumbstripsWindow.childNodes;
	
	for (var i = 0; i < childNodes.length; i++) 
	{
        var sourceUrl = childNodes[i].getAttribute("SourceUrl");
        var webPageNode = thumbstrips_GetFilmstrip().GetWebPageNodeByUrl(sourceUrl);
        
        if(webPageNode!=null)
        {            
            if(this.DoesMatchSearch(webPageNode.GetThumbnail()))
            {
                childNodes[i].removeAttribute("hidden");
            }
            else
            {
                childNodes[i].setAttribute("hidden", true);
            }
        }
    }
}

function thumbstripsFilmstripRendererRelocateThumbnailContainer(sourceUrl, newLocationX)
{   
    var sortManager = new thumbstripsSortManager();
    sortManager.ChangeCurrentSortingPreference(true, false, false, false);
    sortManager.SetSortMode(sortModeManually);
    sortManager = null;
    
    var childNodes = this.m_thumbstripsWindow.childNodes;
    var movingToLastNode = true;
    
	for (var i = 0; i < childNodes.length; i++) 
	{      	    
	    if(childNodes[i].boxObject.screenX > newLocationX)
	    {	       
            thumbstrips_GetFilmstrip().RelocateThumbnailBeforeNode(sourceUrl, childNodes[i].getAttribute("SourceUrl"));            
            movingToLastNode = false;
            break;
	    }
	}

    if(movingToLastNode==true)
    {
        thumbstrips_GetFilmstrip().RelocateThumnbailToEnd(sourceUrl);            
    }
    
	this.Draw(true);
}

function thumbstripsFilmstripRendererOnMenuPopupShowing(isShowing, targetPopup)
{
    if(isShowing==true)
    {
        targetPopup.parentNode.style.color = "#81D3E9";    
    }
    else
    {
        targetPopup.parentNode.style.color = "white";        
    }
}

function thumbstripsFilmstripRendererOnMenuMouseOver(isMouseOver, parentButton)
{
    if(isMouseOver==true)
    {
        parentButton.image="chrome://thumbstrips/skin/arrow_down.gif";
        parentButton.style.color = "#81D3E9";   
    }
    else
    {
        parentButton.image="chrome://thumbstrips/skin/arrow_right.gif";    
        parentButton.style.color = "white";   
    }
}