// ********************************************************************************** //
// The contents of this file are subject to the Mozilla Public License Version 1.1    //
// (the "License"); you may not use this file except in compliance with the License.  //
// You may obtain a copy of the License at http://www.mozilla.org/MPL/                //
//                                                                                    //
// Software distributed under the License is distributed on an "AS IS" basis,         //
// WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License for the  //
// specific language governing rights and limitations under the License.              //
//                                                                                    //
// The Original Code provided by Mozilla's Firefox is XUL, Javascript, and CSS.       // 
// All Rights Reserved. 
// Contributor - Intuit Inc. (c) 2007                                                 //
// ********************************************************************************** //

// -- INITIALIZATION -- //
function thumbstripsWebPageThumbnailArray()
{
    this.m_thumbnails = new Array();
}

thumbstripsWebPageThumbnailArray.prototype.UpdateThumbnail = thumbstripsWebPageThumbnailArrayUpdateThumbnail;
thumbstripsWebPageThumbnailArray.prototype.UpdateThumbnailFromContent = thumbstripsWebPageThumbnailArrayUpdateThumbnailFromContent;
thumbstripsWebPageThumbnailArray.prototype.FindByUrl = thumbstripsWebPageThumbnailArrayFindByUrl;
thumbstripsWebPageThumbnailArray.prototype.ClearContents = thumbstripsWebPageThumbnailArrayClearContents;

function thumbstripsWebPageThumbnailArrayUpdateThumbnail(webPageThumbnail)
{
    this.m_thumbnails[webPageThumbnail.m_url] = webPageThumbnail;
}

function thumbstripsWebPageThumbnailArrayUpdateThumbnailFromContent(content)
{
    var targetUrl = GetCurrentUrl();
    
    if(this.m_thumbnails[targetUrl]==null)
    {
        this.m_thumbnails[targetUrl] = new thumbstripsWebPageThumbnailNode(targetUrl, null, 0, 0, 0);
    }
    
    this.m_thumbnails[targetUrl].UpdateContents(content);
}

function thumbstripsWebPageThumbnailArrayFindByUrl(targetUrl)
{
    return this.m_thumbnails[targetUrl];
}

function thumbstripsWebPageThumbnailArrayClearContents()
{
    for(var i = this.m_thumbnails.length - 1; i > -1; i--)
    {
        this.m_thumbnails[i] = null;
    }
    
    this.m_thumbnails = null;
    this.m_thumbnails = new Array();
}